// Copyright 2019, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Authors: Patrick Brosi <brosi@informatik.uni-freiburg.de>

#ifndef OSMFIXER_INDEX_STATIDX_H_
#define OSMFIXER_INDEX_STATIDX_H_

#include <map>
#include <string>
#include <vector>
#include "util/geo/Geo.h"

namespace osmfixer {

typedef std::map<std::string, std::vector<std::string>> OsmAttrs;

struct Station{
  size_t osmid;
  util::geo::DPoint pos;
  OsmAttrs attrs;
};

class StatIdx {
 public:
  StatIdx() {}

  void readFromFile(const std::string& path);

 private:
  void addStation(size_t id, double lat, double lng, const OsmAttrs& attrs);

  void initIndex();

  std::vector<Station> _stations;
  util::geo::DBox _bbox;
};
}

#endif
